'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames5 = require('classnames');

var _classnames6 = _interopRequireDefault(_classnames5);

var _uxcoreDropdown = require('uxcore-dropdown');

var _uxcoreDropdown2 = _interopRequireDefault(_uxcoreDropdown);

var _uxcoreButton = require('uxcore-button');

var _uxcoreButton2 = _interopRequireDefault(_uxcoreButton);

var _reactLifecyclesCompat = require('react-lifecycles-compat');

var _CascadeMultiPanel = require('./CascadeMultiPanel');

var _CascadeMultiPanel2 = _interopRequireDefault(_CascadeMultiPanel);

var _CascadeMultiModal = require('./CascadeMultiModal');

var _CascadeMultiModal2 = _interopRequireDefault(_CascadeMultiModal);

var _locale = require('./locale');

var _locale2 = _interopRequireDefault(_locale);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * CascadeMultiSelect Component for uxcore
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author changming<changming.zy@alibaba-inc.com>
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2015-2017, Uxcore Team, Alinw.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var CASCADER_SELECT_PREFIXCLS = 'kuma-cascader';

var makeOptionsChecked = function makeOptionsChecked() {
  var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var options = arguments[1];

  // 没有value则需要设置check为false
  var valueStr = value.map(function (i) {
    return '' + i;
  });
  for (var i = 0, l = options.length; i < l; i++) {
    var item = options[i];
    var containIdx = valueStr.indexOf('' + item.value);
    if (containIdx > -1) {
      item.checked = true;
      valueStr.splice(containIdx, 1);
    } else {
      item.checked = false;
    }
    if (item.children && item.children.length) {
      makeOptionsChecked(valueStr, item.children);
    }
  }
};

function valueEqual(v1, v2) {
  if (v1 && v2) {
    return JSON.stringify(v1) === JSON.stringify(v2);
  }
  return true;
}

var CascadeMultiSelect = function (_React$Component) {
  _inherits(CascadeMultiSelect, _React$Component);

  CascadeMultiSelect.getDerivedStateFromProps = function getDerivedStateFromProps(props, state) {
    var propValue = props.value;
    var stateValue = state.value,
        prevPropValue = state.prevPropValue;

    var value = void 0;
    if (!valueEqual(propValue, prevPropValue)) {
      value = propValue;
    } else {
      value = stateValue;
    }
    var displayValue = CascadeMultiSelect.getInputValue(props, value);
    return { value: value, prevPropValue: propValue, displayValue: displayValue };
  };

  CascadeMultiSelect.getInputValue = function getInputValue(props, value) {
    var options = props.options,
        beforeRender = props.beforeRender,
        locale = props.locale,
        labelWithPath = props.labelWithPath;

    if (beforeRender) {
      makeOptionsChecked(value, options);
      return beforeRender(value, options);
    }

    var arr = [];
    if (value && value.length) {
      for (var i = 0; i < value.length; i += 1) {
        arr.push(labelWithPath ? CascadeMultiSelect.getValueLabelWithPath(options, value[i], locale) : CascadeMultiSelect.getValueLabel(options, value[i], locale));
      }
    }
    return arr.join(CascadeMultiSelect.separator);
  };

  CascadeMultiSelect.getValueLabel = function getValueLabel(dataList, key, locale) {
    var back = '';
    if (dataList && dataList.length) {
      for (var i = 0; i < dataList.length; i += 1) {
        if (dataList[i].value === key) {
          return dataList[i].children && dataList[i].children.length ? dataList[i].label + ' (' + (0, _locale2["default"])(locale).all + ')' : dataList[i].label;
        }
        if (dataList[i].children) {
          var res = CascadeMultiSelect.getValueLabel(dataList[i].children, key, locale);
          back = res || back;
        }
      }
    }
    return back;
  };

  CascadeMultiSelect.getValueLabelWithPath = function getValueLabelWithPath(dataList, key, locale) {
    var path = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : [];

    var back = '';
    if (dataList && dataList.length) {
      for (var i = 0; i < dataList.length; i += 1) {
        if (dataList[i].value === key) {
          var prefix = path.length > 0 ? path.map(function (item) {
            return item.label;
          }).join('/') + '/' : '';
          return dataList[i].children && dataList[i].children.length ? '' + prefix + dataList[i].label + ' (' + (0, _locale2["default"])(locale).all + ')' : '' + prefix + dataList[i].label;
        }
        if (dataList[i].children) {
          var newPath = [].concat(_toConsumableArray(path), [dataList[i]]);
          var res = CascadeMultiSelect.getValueLabelWithPath(dataList[i].children, key, locale, newPath);
          back = res || back;
        }
      }
    }
    return back;
  };

  function CascadeMultiSelect(props) {
    _classCallCheck(this, CascadeMultiSelect);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.state = {
      value: props.value || props.defaultValue,
      displayValue: '',
      showSubMenu: false,
      result: {}
    };
    _this.hasChanged = false;
    _this.onOk = _this.onOk.bind(_this);
    _this.handleSelect = _this.handleSelect.bind(_this);
    _this.handleItemClick = _this.handleItemClick.bind(_this);
    _this.handleStopPropagation = _this.handleStopPropagation.bind(_this);
    return _this;
  }

  CascadeMultiSelect.prototype.componentDidMount = function componentDidMount() {
    var _props = this.props,
        value = _props.value,
        defaultValue = _props.defaultValue;

    this.setInputValue(value || defaultValue);
  };

  CascadeMultiSelect.prototype.onOk = function onOk() {
    var _this2 = this;

    if (!this.hasChanged) {
      return;
    }
    var _state = this.state,
        value = _state.value,
        result = _state.result;

    var displayValue = CascadeMultiSelect.getInputValue(this.props, value);
    var valueList = result.valueList,
        labelList = result.labelList,
        leafList = result.leafList,
        cascadeSelected = result.cascadeSelected;

    this.setState({
      displayValue: displayValue,
      value: value
    }, function () {
      _this2.props.onOk(valueList, labelList, leafList, cascadeSelected);
    });
  };

  CascadeMultiSelect.prototype.onCancel = function onCancel() {
    var _this3 = this;

    var _state2 = this.state,
        value = _state2.value,
        result = _state2.result;

    this.setState({
      displayValue: CascadeMultiSelect.getInputValue(this.props, value),
      value: value,
      result: result
    }, function () {
      _this3.props.onCancel();
    });
  };

  CascadeMultiSelect.prototype.onCleanSelect = function onCleanSelect() {
    var _this4 = this;

    var _props2 = this.props,
        isCleanDisabledLabel = _props2.isCleanDisabledLabel,
        options = _props2.options;

    var prevValue = this.state.value;
    var displayValue = '';
    var value = [];
    var labelList = [];
    var leafList = [];
    var result = {};
    if (!isCleanDisabledLabel) {
      var data = (0, _utils.getDisabledValueLabel)(options, prevValue);
      leafList = data.leafNodes;
      data.disabledNodes.forEach(function (item) {
        value.push(item.value);
        labelList.push(item.label);
      });
      result.labelList = labelList;
      result.valueList = value;
      result.leafList = leafList;
      displayValue = CascadeMultiSelect.getInputValue(this.props, value);
    }
    this.setState({
      value: value,
      displayValue: displayValue,
      result: result
    }, function () {
      _this4.props.onOk(value, labelList, leafList);
      _this4.props.onSelect(value, labelList, leafList);
    });
    this.hasChanged = true;
  };

  CascadeMultiSelect.prototype.onDropDownVisibleChange = function onDropDownVisibleChange(visible) {
    var disabled = this.props.disabled;

    if (!disabled) {
      this.setState({ showSubMenu: visible });
    }
    if (!visible) {
      this.onCancel();
    }
  };

  CascadeMultiSelect.prototype.getValueLabel = function getValueLabel(dataList, key) {
    var back = '';
    if (dataList && dataList.length) {
      for (var i = 0; i < dataList.length; i += 1) {
        if (dataList[i].value === key) {
          return dataList[i].children && dataList[i].children.length ? dataList[i].label + ' (' + (0, _locale2["default"])(this.props.locale).all + ')' : dataList[i].label;
        }
        if (dataList[i].children) {
          var res = this.getValueLabel(dataList[i].children, key);
          back = res || back;
        }
      }
    }
    return back;
  };

  CascadeMultiSelect.prototype.setInputValue = function setInputValue(value) {
    var displayValue = CascadeMultiSelect.getInputValue(this.props, value);
    this.setState({ displayValue: displayValue, value: value });
  };

  CascadeMultiSelect.prototype.setPanelWidth = function setPanelWidth() {
    var cascadeSize = this.props.cascadeSize;

    var style = {};
    var width = (0, _utils.getWidthStyle)(this.refUls, 150);
    var resultPanelWidth = (0, _utils.getWidthStyle)(this.refResultPanel, 220);
    style.width = 0;
    for (var i = 0; i < cascadeSize; i += 1) {
      style.width += parseInt(width, 0);
    }
    style.width += parseInt(resultPanelWidth, 0) + 2;
    this.resultPanelWidth = parseInt(resultPanelWidth, 0);
    return style;
  };

  CascadeMultiSelect.prototype.handleSelect = function handleSelect(valueList, labelList, leafList, cascadeSelected) {
    var _this5 = this;

    this.setState({
      displayValue: CascadeMultiSelect.getInputValue(this.props, valueList),
      value: valueList,
      result: {
        valueList: valueList,
        labelList: labelList,
        leafList: leafList,
        cascadeSelected: cascadeSelected
      }
    }, function () {
      _this5.props.onOk(valueList, labelList, leafList, cascadeSelected);
      _this5.props.onSelect(valueList, labelList, leafList, cascadeSelected);
    });
    this.hasChanged = true;
  };

  CascadeMultiSelect.prototype.handleItemClick = function handleItemClick() {
    var _props3;

    (_props3 = this.props).onItemClick.apply(_props3, arguments);
  };

  CascadeMultiSelect.prototype.handleStopPropagation = function handleStopPropagation(e) {
    var tagName = e.target.tagName;

    if (tagName === 'DIV') {
      e.stopPropagation();
    }
  };

  CascadeMultiSelect.prototype.renderInput = function renderInput() {
    var _classnames;

    var _props4 = this.props,
        prefixCls = _props4.prefixCls,
        placeholder = _props4.placeholder,
        locale = _props4.locale,
        readOnly = _props4.readOnly,
        disabled = _props4.disabled;
    var displayValue = this.state.displayValue;

    if (readOnly) {
      return _react2["default"].createElement(
        'span',
        null,
        displayValue
      );
    }
    return _react2["default"].createElement(
      'div',
      null,
      !displayValue.length ? _react2["default"].createElement(
        'div',
        { className: CASCADER_SELECT_PREFIXCLS + '-placeholder' },
        placeholder || (0, _locale2["default"])(locale).placeholder
      ) : _react2["default"].createElement(
        'div',
        { className: (0, _classnames6["default"])([prefixCls + '-text-result']) },
        _react2["default"].createElement('input', {
          className: (0, _classnames6["default"])((_classnames = {}, _defineProperty(_classnames, prefixCls + '-text-result-input', true), _defineProperty(_classnames, prefixCls + '-text-result-input-disabled', disabled), _classnames)),
          value: displayValue,
          onChange: function onChange() {}
        })
      )
    );
  };

  CascadeMultiSelect.prototype.renderCloseIcon = function renderCloseIcon() {
    var _this6 = this;

    var disabled = this.props.disabled;

    if (disabled) {
      return null;
    }
    return _react2["default"].createElement(
      'div',
      { className: CASCADER_SELECT_PREFIXCLS + '-close-wrap' },
      _react2["default"].createElement('i', {
        className: 'kuma-icon kuma-icon-error',
        onClick: function onClick(e) {
          _this6.onCleanSelect();
          e.preventDefault();
          e.stopPropagation();
        }
      })
    );
  };

  CascadeMultiSelect.prototype.renderContent = function renderContent() {
    var _classnames2, _classnames3, _classnames4;

    var _props5 = this.props,
        className = _props5.className,
        prefixCls = _props5.prefixCls,
        theSize = _props5.size,
        jsxsize = _props5.jsxsize,
        allowClear = _props5.allowClear,
        disabled = _props5.disabled;
    var _state3 = this.state,
        displayValue = _state3.displayValue,
        showSubMenu = _state3.showSubMenu;


    var size = jsxsize || theSize;

    return _react2["default"].createElement(
      'div',
      {
        className: (0, _classnames6["default"])((_classnames2 = {}, _defineProperty(_classnames2, className, true), _defineProperty(_classnames2, prefixCls + '-input', !disabled), _defineProperty(_classnames2, prefixCls + '-' + size, !!size), _defineProperty(_classnames2, CASCADER_SELECT_PREFIXCLS + '-wrapper', true), _defineProperty(_classnames2, CASCADER_SELECT_PREFIXCLS + '-disabled', disabled), _defineProperty(_classnames2, CASCADER_SELECT_PREFIXCLS + '-clearable', !disabled && allowClear && displayValue.length > 0), _classnames2))
      },
      _react2["default"].createElement(
        'div',
        {
          className: (0, _classnames6["default"])((_classnames3 = {}, _defineProperty(_classnames3, CASCADER_SELECT_PREFIXCLS + '-text', true), _defineProperty(_classnames3, prefixCls + '-' + size, !!size), _classnames3))
        },
        _react2["default"].createElement(
          'div',
          { className: CASCADER_SELECT_PREFIXCLS + '-trigger' },
          this.renderInput()
        )
      ),
      _react2["default"].createElement(
        'div',
        {
          className: (0, _classnames6["default"])((_classnames4 = {}, _defineProperty(_classnames4, CASCADER_SELECT_PREFIXCLS + '-arrow', true), _defineProperty(_classnames4, CASCADER_SELECT_PREFIXCLS + '-arrow-reverse', showSubMenu), _classnames4))
        },
        _react2["default"].createElement('i', { className: 'kuma-icon kuma-icon-triangle-down' })
      ),
      this.renderCloseIcon()
    );
  };

  CascadeMultiSelect.prototype.renderCascadeMultiPanel = function renderCascadeMultiPanel() {
    var _this7 = this;

    var _props6 = this.props,
        dropdownClassName = _props6.dropdownClassName,
        prefixCls = _props6.prefixCls;
    var value = this.state.value;

    return _react2["default"].createElement(
      'div',
      { className: (0, _classnames6["default"])(prefixCls + '-select-panel-content') },
      _react2["default"].createElement(
        'div',
        { className: prefixCls + '-select-panel-wrap' },
        _react2["default"].createElement(_CascadeMultiPanel2["default"], _extends({}, this.props, {
          className: dropdownClassName,
          value: value,
          ref: function ref(r) {
            _this7.CascadeMulti = r;
          },
          onSelect: this.handleSelect,
          onItemClick: this.handleItemClick,
          mode: 'mix'
        })),
        this.renderFooter()
      )
    );
  };

  CascadeMultiSelect.prototype.renderFooter = function renderFooter() {
    var _props7 = this.props,
        prefixCls = _props7.prefixCls,
        locale = _props7.locale;

    return _react2["default"].createElement(
      'div',
      {
        className: (0, _classnames6["default"])(prefixCls + '-select-footer'),
        style: this.setPanelWidth(),
        onClick: this.handleStopPropagation
      },
      _react2["default"].createElement(
        _uxcoreButton2["default"],
        {
          onClick: this.onOk
        },
        (0, _locale2["default"])(locale).ok
      )
    );
  };

  CascadeMultiSelect.prototype.render = function render() {
    var _this8 = this;

    var _props8 = this.props,
        disabled = _props8.disabled,
        getPopupContainer = _props8.getPopupContainer,
        readOnly = _props8.readOnly;

    if (readOnly) {
      return this.renderInput();
    }
    if (disabled) {
      return this.renderContent();
    }
    var CascadeMultiComponent = this.renderCascadeMultiPanel();
    return _react2["default"].createElement(
      _uxcoreDropdown2["default"],
      {
        overlay: CascadeMultiComponent,
        trigger: ['click'],
        minOverlayWidthMatchTrigger: false,
        onVisibleChange: function onVisibleChange(visible) {
          _this8.onDropDownVisibleChange(visible);
        },
        getPopupContainer: getPopupContainer
      },
      this.renderContent()
    );
  };

  return CascadeMultiSelect;
}(_react2["default"].Component);

CascadeMultiSelect.separator = ' , ';


CascadeMultiSelect.defaultProps = {
  className: '',
  prefixCls: 'kuma-cascade-multi',
  config: [],
  options: [],
  cascadeSize: 3,
  value: [],
  notFoundContent: '',
  allowClear: true,
  locale: 'zh-cn',
  onSelect: function onSelect() {},
  onItemClick: function onItemClick() {},

  size: 'large',
  jsxsize: '',
  placeholder: '',
  disabled: false,
  defaultValue: [],
  dropdownClassName: '',
  onOk: function onOk() {},
  onCancel: function onCancel() {},
  getPopupContainer: null,

  beforeRender: null,
  readOnly: false,
  keyCouldDuplicated: false,
  isCleanDisabledLabel: false,
  labelWithPath: false
};

CascadeMultiSelect.propTypes = {
  className: _propTypes2["default"].string,
  prefixCls: _propTypes2["default"].string,
  config: _propTypes2["default"].array,
  options: _propTypes2["default"].array,
  cascadeSize: _propTypes2["default"].number,
  value: _propTypes2["default"].array,
  notFoundContent: _propTypes2["default"].string,
  allowClear: _propTypes2["default"].bool,
  locale: _propTypes2["default"].string,
  onSelect: _propTypes2["default"].func,
  onItemClick: _propTypes2["default"].func,

  size: _propTypes2["default"].oneOf(['large', 'middle', 'small']),
  jsxsize: _propTypes2["default"].oneOf(['large', 'middle', 'small']),
  placeholder: _propTypes2["default"].string,
  disabled: _propTypes2["default"].bool,
  defaultValue: _propTypes2["default"].array,
  dropdownClassName: _propTypes2["default"].string,
  onOk: _propTypes2["default"].func,
  onCancel: _propTypes2["default"].func,
  getPopupContainer: _propTypes2["default"].func,

  beforeRender: _propTypes2["default"].func,
  readOnly: _propTypes2["default"].bool,
  keyCouldDuplicated: _propTypes2["default"].bool,
  isCleanDisabledLabel: _propTypes2["default"].bool,
  labelWithPath: _propTypes2["default"].bool
};

CascadeMultiSelect.displayName = 'CascadeMultiSelect';

CascadeMultiSelect.CascadeMultiPanel = _CascadeMultiPanel2["default"];
CascadeMultiSelect.CascadeMultiModal = _CascadeMultiModal2["default"];

(0, _reactLifecyclesCompat.polyfill)(CascadeMultiSelect);

module.exports = CascadeMultiSelect;